local tmp_vec1 = Vector3()
converted_count = 0 
g_feedback_expire_t = 0
ECMJammerBase = ECMJammerBase or class(UnitBase)
ECMJammerBase._NET_EVENTS = {
	battery_low = 1,
	battery_empty = 2,
	feedback_start = 3,
	feedback_stop = 4,
	jammer_active = 5,
	feedback_flash = 6,
	feedback_restart = 7
}
ECMJammerBase.battery_life_multiplier = {
	1,
	1.25,
	1.5
}

function ECMJammerBase:sync_net_event(event_id)
	local net_events = self._NET_EVENTS
	if event_id == net_events.battery_low then
		self:_set_battery_low()
	elseif event_id == net_events.battery_empty then
		self:_set_battery_empty()
	elseif event_id == net_events.feedback_start then
		converted_count = 0
		self:_set_feedback_active(true)
		local range = tweak_data.upgrades.ecm_jammer_base_range
		local detected = World:find_units_quick("sphere", self._unit:position(), range, managers.slot:get_mask("enemies"))
		for _, unit in ipairs(detected) do
			if alive(unit:body("mover_blocker")) then
				unit:movement():set_team(managers.groupai:state():team_data("converted_enemy")) --Change brain
				managers.network:session():send_to_peers("sync_char_team", unit, 1)      --Change brain for clients
				unit:contour():add("mark_unit", true)
				unit:contour():flash("mark_unit", 0.2)
			end
		end

	elseif event_id == net_events.feedback_stop then
		converted_count = 0
		self:_set_feedback_active(false)
	elseif event_id == net_events.jammer_active then
		self:set_active(true)
	elseif event_id == net_events.feedback_flash then
		self._unit:contour():flash("deployable_active", 0.15)
	elseif event_id == net_events.feedback_restart then
		self._unit:sound_source():post_event("ecm_jammer_ready")
	end
end

function ECMJammerBase._detect_and_give_dmg(hit_pos, device_unit, user_unit, range)
	log('Mxinside')
	local mvec3_dis_sq = mvector3.distance_sq
	local slotmask = managers.slot:get_mask("bullet_impact_targets")
	local splinters = {
		mvector3.copy(hit_pos)
	}
	local dirs = {
		Vector3(range, 0, 0),
		Vector3(-range, 0, 0),
		Vector3(0, range, 0),
		Vector3(0, -range, 0),
		Vector3(0, 0, range),
		Vector3(0, 0, -range)
	}
	local pos = tmp_vec1
	for _, dir in ipairs(dirs) do
		mvector3.set(pos, dir)
		mvector3.add(pos, hit_pos)
		local splinter_ray = World:raycast("ray", hit_pos, pos, "slot_mask", slotmask)
		pos = (splinter_ray and splinter_ray.position or pos) - dir:normalized() * math.min(splinter_ray and splinter_ray.distance or 0, 10)
		local near_splinter = false
		for _, s_pos in ipairs(splinters) do
			if mvector3.distance_sq(pos, s_pos) < 300 then
				near_splinter = true
			else
			end
		end
		if not near_splinter then
			table.insert(splinters, mvector3.copy(pos))
		end
	end
	local range_sq = range * range
	local half_range_sq = range * 0.5
	half_range_sq = half_range_sq * half_range_sq
	local function _chk_apply_dmg_to_char(u_data)
		if not u_data.char_tweak.ecm_vulnerability then
			return
		end
		if u_data.unit.brain and u_data.unit:brain().is_hostage and u_data.unit:brain():is_hostage() then
			return
		end
		if u_data.unit:anim_data() and u_data.unit:anim_data().act then
			return
		end
		if math.random() >= u_data.char_tweak.ecm_vulnerability then
			return
		end
		local head_pos = u_data.unit:movement():m_head_pos()
		local dis_sq = mvec3_dis_sq(head_pos, hit_pos)
		if dis_sq > range_sq then
			return
		end
		-- Mxcode from here!
		local t = TimerManager:game():time()
		max_converted = managers.player:upgrade_value("player", "convert_enemies_max_minions", 0) -- now is hardcoded
		--log('max_converted')
		--log(tostring(max_converted))
		for i_splinter, s_pos in ipairs(splinters) do
			local ray_hit = World:raycast("ray", s_pos, head_pos, "slot_mask", slotmask, "ignore_unit", u_data.unit, "report")
			if not ray_hit and (i_splinter == 1 or dis_sq < half_range_sq) then
				local attack_data = {
					variant = "stun",
					damage = 0,
					attacker_unit = alive(user_unit) and user_unit or nil,
					weapon_unit = device_unit,
					col_ray = {
						position = mvector3.copy(head_pos),
						ray = head_pos - s_pos:normalized()
					}
				}
				special_unit_ids = {
					"shield",
					"spooc",
					"tank",
					"tank_hw",
					"tank_green",
					"tank_black",
					"tank_skull",
					"taser",
					"medic",
					"sniper",
					"phalanx_minion",
					"phalanx_vip",
					"swat_turret",
					"biker_boss",
					"chavez_boss",
					"mobster_boss",
					"hector_boss",
					"hector_boss_no_armor",
					"drug_lord_boss",
					"drug_lord_boss_stealth"
				}
				local function is_special (tab, val)
				    for index, value in ipairs(tab) do
				        if value == val then
				            return true
				        end
				    end
				    return false
				end
				local special_check = is_special(special_unit_ids,u_data.unit:base()._tweak_table)
				if managers.player:has_category_upgrade("player", "ecm_convert_enemies") and not special_check then
					--log(tostring(u_data.unit:movement():team().id))
					--log(tostring(tostring(u_data.unit:movement():team().id) == "criminal1")) 
					if tostring(u_data.unit:movement():team().id) ~= "mobster1" then
						u_data.unit:character_damage():damage_explosion(attack_data) -- If not converted apply the Feddback effect
						if alive(u_data.unit:body("mover_blocker")) and converted_count < max_converted then                      -- thanks to luffy
							log('Converting...')
							--managers.groupai:state():convert_hostage_to_criminal(u_data.unit) -- thanks to luffy
							--managers.groupai:state():criminal_spotted(u_data.unit))
							u_data.unit:movement():set_team(managers.groupai:state():team_data("mobster1")) --Change brain
							managers.network:session():send_to_peers("sync_char_team", u_data.unit, 5)      --Change brain for clients
							u_data.unit:contour():add("medic_heal", true)
  							u_data.unit:contour():flash("medic_heal", 0.2)
							converted_count = converted_count + 1 
						end				
					else 
						log('is_converted')
						--if t > (g_feedback_expire_t - 1) and alive(u_data.unit:body("mover_blocker")) then
							--managers.network:session():send_to_peers("picked_up_sentry_gun", self._unit, nil)
							--[[local action_data = {
								damage = math.huge, --(Ultra * math.huge) damage.
								damage_effect = u_data.unit:character_damage()._HEALTH_INIT * 2,
								attacker_unit = managers.player:player_unit(),
								attack_dir = Vector3(0,0,0),
								name_id = 'rambo', --Only in rambo style bulldosers can be killed
								col_ray = {
									position = u_data.unit:position(),
									body = u_data.unit:body( "body" ),
								}
							}
							u_data.unit:character_damage():damage_melee(action_data)]]
						--end
					end
				else
					--log('Special')
					u_data.unit:character_damage():damage_explosion(attack_data)
				end
			end
		end
	end
	for u_key, u_data in pairs(managers.enemy:all_enemies()) do
		_chk_apply_dmg_to_char(u_data)	
	end
	for u_key, u_data in pairs(managers.enemy:all_civilians()) do
		_chk_apply_dmg_to_char(u_data)
	end
end

function ECMJammerBase:set_feedback_active()
	if not managers.network:session() then
		return
	end
	if Network:is_client() then
		self:_send_net_event_to_host(self._NET_EVENTS.feedback_start)
	else
		self:_set_feedback_active(true)
	end
end
