local data = SkillTreeTweakData.init
function SkillTreeTweakData:init(tweak_data)
	data(self, tweak_data)
	local digest = function(value)
		return Application:digest_value(value, true)
	end
	self.tier_unlocks = {
		digest(0),
		digest(1),
		digest(3),
		digest(18)
	}

	-- I like to use table.insert because self.skill_pages_order is a table and 
	-- using the insert it won't overrie the skill tree of the other modders
	-- log(tostring(type(self.skill_pages_order)))
	--I use contain_my_skilltree for check if there is a mine skill tree (example:added by another my mod)
	local function contain_my_skilltree (tab, val)
	    for index, value in ipairs(tab) do
	        if value == val then
	            return true
	        end
	    end
	    return false
	end
	if not contain_my_skilltree(self.skill_pages_order,"predator") then
		table.insert(self.skill_pages_order,"predator")
		self.skilltree.predator = {
			name_id = "predator_skilltree",
			desc_id = "predator_skilltree_desc"
		}
	end

-- Skill cost infos
-- Tier 0 and 1
--       base = self.costs.default
--       aced = self.costs.pro

-- Tier 2 and 3
--       base = self.costs.hightier
--       aced = self.costs.hightierpro

--Recon DONE icon
	self.skills.predator_recon_ECM = {  
	["name_id"] = "menu_predator_recon_ecm",
	["desc_id"] = "menu_predator_recon_ecm_desc",
	["icon_xy"] = {6, 2},
	[1] = {
		upgrades = {
			"ecm_jammer_recon_enable"
		},
		cost = self.costs.default
	},
	[2] = {
		upgrades = {
			"ecm_jammer_recon_dmg_boost"
		},
		cost = self.costs.pro
	}
	}

--Improved battery DONE icon
	self.skills.improved_battery = {  
		["name_id"] = "menu_improved_battery",
		["desc_id"] = "menu_improved_battery_desc",
		["icon_xy"] = {6, 3},
		[1] = {
			upgrades = {
				"ecm_jammer_feedback_duration_boost"
			},
			cost = self.costs.default
		},
		[2] = {
			upgrades = {
				"ecm_jammer_feedback_duration_boost_2"
			},
			cost = self.costs.pro
		}
	}

--solar_panel DONE
	self.skills.solar_panel = {  
		["name_id"] = "menu_solar_panel",
		["desc_id"] = "menu_solar_panel_desc",
		["icon_xy"] = {1, 4},
		[1] = {
			upgrades = {
				"ecm_jammer_recon_cooldown_boost_1"
			},
			cost = self.costs.hightier
		},
		[2] = {
			upgrades = {
				"ecm_jammer_recon_cooldown_boost_2"				
			},
			cost = self.costs.hightierpro
		}
	}

--more_frequencies 50% Working base
	self.skills.more_frequencies = {  
		["name_id"] = "menu_more_frequencies",
		["desc_id"] = "menu_more_frequencies_desc",
		["icon_xy"] = {8, 0},
		[1] = {
			upgrades = {
				"ecm_jammer_recon_retrigger"
			},
			cost = self.costs.hightier
		},
		[2] = {
			upgrades = {
				
			},
			cost = self.costs.hightierpro
		}
	}

--wide_pockets DONE icon
	self.skills.wide_pockets = {  
		["name_id"] = "menu_wide_pockets",
		["desc_id"] = "menu_wide_pockets_desc",
		["icon_xy"] = {9, 4},
		[1] = {
			upgrades = {
				"ecm_jammer_quantity_increase_1"
				--,"deploy_interact_faster_1"
			},
			cost = self.costs.hightier
		},
		[2] = {
			upgrades = {
				"second_deployable_1"
			},
			cost = self.costs.hightierpro
		}
	}

--totally_jammed 0%
	self.skills.totally_jammed = {  
		["name_id"] = "menu_totally_jammed",
		["desc_id"] = "menu_totally_jammed_desc",
		["icon_xy"] = {0, 0},
		[1] = {
			upgrades = {
			},
			cost = self.costs.hightier
		},
		[2] = {
			upgrades = {
				
			},
			cost = self.costs.hightierpro
		}
	}

-- This is for insert our skilltre in main tree
table.insert(self.trees,{
			name_id = "predator_recon_tree",-- id for localization
			background_texture = "guis/textures/pd2/skilltree/bg_mastermind",
			unlocked = true,
			skill = "predator", -- the name of your skilltree
			tiers = {
					{
						"predator_recon_ECM" 
					},
					{
						"improved_battery",
						"solar_panel"
					},
					{
						"wide_pockets",
						"more_frequencies"
					}, 
					{
						"totally_jammed"
					} 
				}
			})	
end


--[[
TIER0
"recon_ECM" DONE
-- Recon ECM don't work in stealth
-- Base:Feedback now will mark enemies
-- Pro :Enemies marked by Feedback will get 15% more damage
TIER1
"improved_battery" DONE
-- Base:The Feedback duration increased by 25%
-- Pro :The Feedback duration increased by an additional 25% 
"solar_panel"    DONE   
-- Base:The Feedback cooldown is reduced by 10%
-- Pro :The Feedback cooldown is reduced by an additional 10% (10 + 10)
TIER2
"Wide_pockets" DONE
-- Base: You can now equip a second deployable to bring with you. If your deployable is equipped as a secondary deployable, you can only bring half of what you would bring if it was equipped as a primary deployable.
-- Pro : Now you can bring 1 more ECM
"more_frequencies"
-- Base: Now the feedback will trigger also the jammer. the jammer ends when the feedback ends. Max 4 retrigger
-- Pro : Infinite retrigger
TIER3
"totally_jammed" -- Totally Jammed!
-- Base:You can now stun cloakers
-- Pro :"Your ECM Jammer now has a x% chance of overloading the enemy radios, lighting them on fire."
]]